package com.my.framework.web.service;

import com.my.common.core.domain.entity.SysDept;
import com.my.system.service.ISysDeptService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import com.my.common.core.domain.entity.SysUser;
import com.my.common.core.domain.model.LoginUser;
import com.my.common.enums.UserStatus;
import com.my.common.exception.ServiceException;
import com.my.common.utils.MessageUtils;
import com.my.common.utils.StringUtils;
import com.my.system.service.ISysUserService;

import java.util.List;

/**
 * 用户验证处理
 *
 * @author ruoyi
 */
@Service
public class UserDetailsServiceImpl implements UserDetailsService
{
    private static final Logger log = LoggerFactory.getLogger(UserDetailsServiceImpl.class);

    @Autowired
    private ISysUserService userService;
    
    @Autowired
    private SysPasswordService passwordService;

    @Autowired
    private SysPermissionService permissionService;

    @Autowired
    private ISysDeptService deptService;

    // todo 正式环境部署 改为 true
//    private final static boolean h4a_login = false;

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException
    {

        List<SysUser> list = userService.selectUserByUserGuid(username);
        if(list == null || list.size() == 0){
            list =  userService.selectUserByUserName(username);
        }
        if(list == null && list.size() == 0){
            log.info("登录用户：{} 不存在.", username);
            throw new ServiceException(MessageUtils.message("user.not.exists"));
        }
        SysUser user = list.get(0);

        if (StringUtils.isNull(user))
        {
            log.info("登录用户：{} 不存在.", username);
            throw new ServiceException(MessageUtils.message("user.not.exists"));
        }
        else if (UserStatus.DELETED.getCode().equals(user.getDelFlag()))
        {
            log.info("登录用户：{} 已被删除.", username);
            throw new ServiceException(MessageUtils.message("user.password.delete"));
        }
        else if (UserStatus.DISABLE.getCode().equals(user.getStatus()))
        {
            log.info("登录用户：{} 已被停用.", username);
            throw new ServiceException(MessageUtils.message("user.blocked"));
        }

        // H4A登录时注释
//        if(!h4a_login){
//            passwordService.validate(user);
//        }

        return createLoginUser(user);
    }

    public UserDetails createLoginUser(SysUser user)  {
        Long orgId = 0l; // 用户所属单位总关、隶属海关、缉私局、事业单位四大类 的机构id
        String orgCategory = "1";
        SysDept dept = user.getDept();
        SysDept userOrg = deptService.getUserOrg(dept.getAncestors());
        if(userOrg != null ){
            orgId = userOrg.getDeptId();
            orgCategory = userOrg.getOrgCategory();
        }
        return new LoginUser(user.getUserId(), user.getDeptId(), user, orgId, orgCategory, permissionService.getMenuPermission(user));
    }

}
